<?php

namespace PlagScanApi;

require_once  __DIR__ . '/Base.php';
/**
 * Class Groups
 * @author Ingmar Szmais <iszmais@databay.de>
 * @since 20.08.19
 */
class Groups extends Base
{

    /**
     * @param int $groupID
     * @return array|string
     */
    public function get(int $groupID)
    {
        return $this->handler->request('groups/' . $groupID, 'GET', $this->accessToken);
    }

    /**
     * @param string $groupName
     * @param int $groupAdminID
     * @return array|string
     */
    public function add(string $groupName, int $groupAdminID = 0)
    {
        $data['deptName'] = $groupName;

        if ($groupAdminID) {
            $data['deptAdmin'] = $groupAdminID;
        }

        return $this->handler->request('groups', 'POST', $this->accessToken, $data);
    }

    /**
     * @param int $groupID
     * @param array $changes
     * @return array|string
     */
    public function change(int $groupID, array $changes)
    {
        return $this->handler->request('groups/' . $groupID, 'PATCH', $this->accessToken, $changes);
    }

    /**
     * @param int $groupID
     * @return array|string
     */
    public function delete(int $groupID)
    {
        return $this->handler->request('groups/' . $groupID, 'DELETE', $this->accessToken);
    }
}