<?php

require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/class.ilPlagScanAssignmentConfigData.php';

class ilPlagScanAssignmentConfigPersistence
{
    /** @var ilDBPdo $ilDB */
    protected $ilDB;

    public function __construct($ilDB)
    {
        $this->ilDB = $ilDB;
    }

    public function store(ilPlagScanAssignmentConfigData $data)
    {
        $query = 'DELETE FROM psx_assignments WHERE assignment_exc_obj = '
            . $this->ilDB->quote($data->getExerciseObjId(), 'integer')
            . ' AND assignment_id = ' . $this->ilDB->quote($data->getAssignmentId(), 'integer');
        $this->ilDB->query($query);
        $id = $this->ilDB->nextId('psx_assignments');
        $this->ilDB->insert('psx_assignments',
            array(
                'id' => array('integer', $id),
                'assignment_exc_obj' => array('integer', $data->getExerciseObjId()),
                'assignment_id' => array('integer', $data->getAssignmentId()),
                'activation' => array('text', $data->getActivation()),
                'start' => array('text', $data->getStartCheck()),
                'share_result' => array('text', $data->getShareSetting()),
                'result_type' => array('text', $data->getShareType())
            )
        );
    }

    public function getByAssignmentId($id)
    {
        $result = $this->ilDB->query('SELECT * FROM psx_assignments WHERE assignment_id = '
           . $this->ilDB->quote($id, 'integer'));
        $row = $this->ilDB->fetchAssoc($result);
        if($row != null) {
            $data = new ilPlagScanAssignmentConfigData(
                $row['assignment_exc_obj'], $row['assignment_id'], $row['activation'] == 1 ? true : false,
                $row['start'], $row['share_result'], $row['result_type']
            );
        } else {
            $data = new ilPlagScanAssignmentConfigData(
                ilObject::_lookupObjectId(ilUtil::stripSlashes($_GET['ref_id'])),
                $id, false, 'manual', 'none', 'none');
        }
        return $data;
    }
}