<?php
/**
 * @category PlagScanExercise
 * @package PlagScan
 * @author Maximilian Becker <mbecker@databay.de>
 * @copyright 2019 Maximilian Becker / Databay AG
 * @license http://opensource.org/licenses/gpl-license.php GNU Public License
 * @link http://www.databay.de Databay AG
 */

// @codingStandardsIgnoreStart
require_once './Services/UIComponent/classes/class.ilUIHookPluginGUI.php';
// @codingStandardsIgnoreEnd

/**
 * Class ilPlagScanExerciseUIHookGUI
 */
class ilPlagScanExerciseUIHookGUI extends ilUIHookPluginGUI
{
    /**
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     * (Derived method)
     *
     * @param string $a_comp Component
     * @param string $a_part Part
     * @param array  $a_par  Parameter
     *
     * @return array
     */
    public function getHTML($a_comp, $a_part, $a_par = array())
    {
        /** @var ilCtrl $ilCtrl */
        $ilCtrl = $GLOBALS['DIC']->ctrl();
        /** @var ilTemplate $tpl */
        $tpl = $a_par['tpl_obj'];

        // Catch Creation Screen
        if(
            $a_part == 'template_get'
            && $tpl->currentBlock == '__global__'
            && $tpl->tplName == 'tpl.form.html'
            && $ilCtrl->getCmdClass() == 'ilexassignmenteditorgui'
            && isset($_POST['cmd']['addAssignment'])
            && isset($_POST['type'])
            && ($_POST['type'] == "5" || $_POST['type'] == "1")
            && $GLOBALS['PLX_IN_EXEC'] == false)
        {
            $GLOBALS['PLX_IN_EXEC'] = true;
            require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/form/class.ilExAssignmentEditorGUIOverride.php';
            $override_editor = new ilExAssignmentEditorGUIOverride(ilObject::_lookupObjectId((integer)$_GET['ref_id']), false);
            $override_editor->parent = new ilExAssignmentEditorGUI(ilObject::_lookupObjectId((integer)$_GET['ref_id']), false);
            if($_POST['type'] == "5") {
                $form_html = $override_editor->getTextAssignmentCreationForm()->getHtml();
            } else {
                $form_html = $override_editor->getUploadAssignmentCreationForm()->getHtml();
            }
            $GLOBALS['PLX_IN_EXEC'] = false;
            return array("mode" => ilUIHookPluginGUI::REPLACE, 'html' => $form_html );
        }

        // Catch Creation Submit
        if(
            $ilCtrl->getCmdClass() == 'ilexassignmenteditorgui'
            && $ilCtrl->getCmd() == 'saveAssignment'
            && $a_comp == 'Services/Utilities'
            && $a_part == 'redirect'
            && $GLOBALS['PLX_CREATION_DONE'] != true
        )
        {
            require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/class.ilPlagScanAssignmentConfigData.php';
            $GLOBALS['PLX_CREATION_DONE'] = true;
            $config = new ilPlagScanAssignmentConfigData(
                ilObject::_lookupObjectId(ilUtil::stripSlashes($_GET['ref_id'])),
              $this->getLatestAssignmentIdForExercise(ilObject::_lookupObjectId(ilUtil::stripSlashes($_GET['ref_id']))),
              ilUtil::stripSlashes($_POST['psx_activation']) == 1 ? true : false,
              isset($_POST['psx_checkstart']) ? ilUtil::stripSlashes($_POST['psx_checkstart']) : 'none',
                isset($_POST['psx_resultshare']) ?ilUtil::stripSlashes($_POST['psx_resultshare']) : 'none',
              isset($_POST['psx_resulttype']) ?ilUtil::stripSlashes($_POST['psx_resulttype']) : 'none'
            );

            require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/class.ilPlagScanAssignmentConfigPersistence.php';
            $persistence = new ilPlagScanAssignmentConfigPersistence($GLOBALS['DIC']->database());
            $persistence->store($config);

            // Here we extract the assignment-settings for the assignment and
            return array("mode" => ilUIHookPluginGUI::KEEP, "html" => "");
        }

        // Catch Edit Assignment Screen
        if(
            $a_part == 'template_get'
            && $tpl->currentBlock == '__global__'
            && $tpl->tplName == 'tpl.form.html'
            && $ilCtrl->getCmdClass() == 'ilexassignmenteditorgui'
            && $ilCtrl->getCmd('editAssignment')
            && $GLOBALS['PLX_IN_EXEC'] == false)
        {
            $GLOBALS['PLX_IN_EXEC'] = true;
            $assignment = new ilExAssignment((integer)$_GET['ass_id']);
            if($assignment->getAssignmentType() instanceof ilExAssTypeText) {
                require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/form/class.ilExAssignmentEditorGUIOverride.php';
                $override_editor = new ilExAssignmentEditorGUIOverride(ilObject::_lookupObjectId((integer) $_GET['ref_id']),
                    false, $assignment);
                $override_editor->parent = new ilExAssignmentEditorGUI(ilObject::_lookupObjectId((integer) $_GET['ref_id']),
                    false, $assignment);
                $form_html = $override_editor->getTextAssignmentUpdateForm()->getHtml();
                $GLOBALS['PLX_IN_EXEC'] = false;
                return array("mode" => ilUIHookPluginGUI::REPLACE, 'html' => $form_html);
            } else if($assignment->getAssignmentType() instanceof ilExAssTypeUpload) {
                require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/form/class.ilExAssignmentEditorGUIOverride.php';
                $override_editor = new ilExAssignmentEditorGUIOverride(ilObject::_lookupObjectId((integer) $_GET['ref_id']),
                    false, $assignment);
                $override_editor->parent = new ilExAssignmentEditorGUI(ilObject::_lookupObjectId((integer) $_GET['ref_id']),
                    false, $assignment);
                $form_html = $override_editor->getUploadAssignmentUpdateForm()->getHtml();
                $GLOBALS['PLX_IN_EXEC'] = false;
                return array("mode" => ilUIHookPluginGUI::REPLACE, 'html' => $form_html);
            } else {
                return array("mode" => ilUIHookPluginGUI::KEEP, "html" => "");
            }
        }

        // Catch Edit Assignment Submit Screen
        if(
            $ilCtrl->getCmdClass() == 'ilexassignmenteditorgui'
            && $ilCtrl->getCmd() == 'updateAssignment'
            && $a_comp == 'Services/Utilities'
            && $a_part == 'redirect'
        )
        {
            require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/class.ilPlagScanAssignmentConfigData.php';

            $config = new ilPlagScanAssignmentConfigData(
                ilObject::_lookupObjectId(ilUtil::stripSlashes($_GET['ref_id'])),
                ilUtil::stripSlashes($_GET['ass_id']),
                ilUtil::stripSlashes($_POST['psx_activation']) == 1 ? true : false,
                isset($_POST['psx_checkstart']) ? ilUtil::stripSlashes($_POST['psx_checkstart']) : 'none',
                isset($_POST['psx_resultshare']) ?ilUtil::stripSlashes($_POST['psx_resultshare']) : 'none',
                isset($_POST['psx_resulttype']) ?ilUtil::stripSlashes($_POST['psx_resulttype']) : 'none'
            );

            require_once './Customizing/global/plugins/Services/UIComponent/UserInterfaceHook/PlagScanExercise/classes/class.ilPlagScanAssignmentConfigPersistence.php';
            $persistence = new ilPlagScanAssignmentConfigPersistence($GLOBALS['DIC']->database());
            $persistence->store($config);

            return array("mode" => ilUIHookPluginGUI::KEEP, "html" => "");
        }

        // Catch Submission and Grading Screen / Assignment
        if(
            $a_part == 'template_get'
            && $tpl->currentBlock == 'tbl_table_end'
            && $ilCtrl->getCmdClass() == 'ilexercisemanagementgui'
            && $ilCtrl->getCmd() == 'members'
        )
        {
            // Do stuff to $a_par['html']
            return array("mode" => ilUIHookPluginGUI::REPLACE, 'html' => $a_par['html']);
        }

        // Catch Submission and Grading Screen / Participant
        if(
            $a_part == 'template_get'
            && $tpl->currentBlock == 'tbl_table_end'
            && $ilCtrl->getCmdClass() == 'ilexercisemanagementgui'
            && $ilCtrl->getCmd() == 'showParticipant'
        )
        {
            // Do stuff to $a_par['html']
            return array("mode" => ilUIHookPluginGUI::REPLACE, 'html' => $a_par['html']);
        }

        // Catch Assignment Overview (to inject eventual plagscan disclosure)
        if(
            $a_part == 'template_get'
            && $a_par['tpl_id'] == 'Modules/Exercise/tpl.assignment_body.html'
            && $ilCtrl->getCmdClass() == 'ilobjexercisegui'
            && $ilCtrl->getCmd() == 'showOverview'
        )
        {
            //worked on assignment id is in
            // <a class="btn btn-default btn-primary" href="ilias.php?ref_id=71&amp;ass_id=1&amp;cmd=editAssignmentText&amp;cmdClass=ilexsubmissiontextgui&amp;cmdNode=ah:kq:ax:b0&amp;baseClass=ilExerciseHandlerGUI">&nbsp;Edit Text&nbsp;</a>
            $a = 1;
            // Do stuff to $a_par['html']
            return array("mode" => ilUIHookPluginGUI::REPLACE, 'html' => $a_par['html']);
        }

        // Catch Working Screen (to inject eventual refusal option)
        if(
            $a_part == 'template_get'
            && $a_par['tpl_id'] == 'Services/Form/tpl.property_form.html'
            && $ilCtrl->getCmdClass() == 'ilexsubmissiontextgui'
            && $ilCtrl->getCmd() == 'editAssignmentText'
        )
        {
            //worked on assignment id is in $_GET
            // Do stuff to $a_par['html']
            return array("mode" => ilUIHookPluginGUI::REPLACE, 'html' => $a_par['html']);
        }


        // Catch Submission Submit to process submission and get eventual refusal option choice
        if(
            $ilCtrl->getCmdClass() == 'ilexsubmissiontextgui'
            && ($ilCtrl->getCmd() == 'updateAssignmentText' || $ilCtrl->getCmd() == 'updateAssignmentTextAndReturn')
            && $a_comp == 'Services/Utilities'
            && $a_part == 'redirect'
        )
        {
            // Here we extract the eventual refusal-choice for the submission and
            return array("mode" => ilUIHookPluginGUI::KEEP, "html" => "");
        }

        return array("mode" => ilUIHookPluginGUI::KEEP, "html" => "");
    }

    /**
     * @SuppressWarnings(PHPMD.UnusedFormalParameter)
     * (Derived method)
     *
     * @param string $a_comp Component
     * @param string $a_part Part
     * @param array  $a_par  Parameter
     *
     * @return void
     */
    public function modifyGUI($a_comp, $a_part, $a_par = array())
    {
        $a = 1;
        // None.
    }

    protected function getLatestAssignmentIdForExercise(int $object_id)
    {
        /** @var ilDBPdo $ilDB */
        $ilDB = $GLOBALS['DIC']->database();
        $result = $ilDB->query('SELECT max(id) as maxId FROM exc_assignment WHERE exc_id = '
            . $ilDB->quote($object_id, 'integer'));
        $row = $ilDB->fetchAssoc($result);
        return $row['maxId'];
    }
}
